Merge tag 'trace-printf-v6.13' of git://git.kernel.org/pub/scm/linux/kernel/git/trace...
[drm/drm-misc.git] / tools / testing / selftests / rcutorture / bin / kvm-test-1-run.sh
blobad79784e552d2d992f55f07aeb8b83d4d1e61321
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0+
4 # Run a kvm-based test of the specified tree on the specified configs.
5 # Fully automated run and error checking, no graphics console.
7 # Execute this in the source tree. Do not run it as a background task
8 # because qemu does not seem to like that much.
10 # Usage: kvm-test-1-run.sh config resdir seconds qemu-args boot_args_in
12 # qemu-args defaults to "-enable-kvm -display none -no-reboot", along
13 # with arguments specifying the number of CPUs
14 # and other options generated from the underlying
15 # CPU architecture.
16 # boot_args_in defaults to value returned by the per_version_boot_params
17 # shell function.
19 # Anything you specify for either qemu-args or boot_args_in is appended to
20 # the default values. The "-smp" value is deduced from the contents of
21 # the config fragment.
23 # More sophisticated argument parsing is clearly needed.
25 # Copyright (C) IBM Corporation, 2011
27 # Authors: Paul E. McKenney <paulmck@linux.ibm.com>
29 T="`mktemp -d ${TMPDIR-/tmp}/kvm-test-1-run.sh.XXXXXX`"
30 trap 'rm -rf $T' 0
32 . functions.sh
33 . $CONFIGFRAG/ver_functions.sh
35 config_template=${1}
36 config_dir=`echo $config_template | sed -e 's,/[^/]*$,,'`
37 title=`echo $config_template | sed -e 's/^.*\///'`
38 resdir=${2}
39 if test -z "$resdir" -o ! -d "$resdir" -o ! -w "$resdir"
40 then
41 echo "kvm-test-1-run.sh :$resdir: Not a writable directory, cannot store results into it"
42 exit 1
44 echo ' ---' `date`: Starting build, PID $$
45 echo ' ---' Kconfig fragment at: $config_template >> $resdir/log
46 touch $resdir/ConfigFragment.input
48 # Combine additional Kconfig options into an existing set such that
49 # newer options win. The first argument is the Kconfig source ID, the
50 # second the to-be-updated file within $T, and the third and final the
51 # list of additional Kconfig options. Note that a $2.tmp file is
52 # created when doing the update.
53 config_override_param () {
54 if test -n "$3"
55 then
56 echo $3 | sed -e 's/^ *//' -e 's/ *$//' | tr -s " " "\012" > $T/Kconfig_args
57 echo " --- $1" >> $resdir/ConfigFragment.input
58 cat $T/Kconfig_args >> $resdir/ConfigFragment.input
59 config_override.sh $T/$2 $T/Kconfig_args > $T/$2.tmp
60 mv $T/$2.tmp $T/$2
64 echo > $T/KcList
65 config_override_param "$config_dir/CFcommon" KcList "`cat $config_dir/CFcommon 2> /dev/null`"
66 config_override_param "$config_template" KcList "`cat $config_template 2> /dev/null`"
67 config_override_param "--gdb options" KcList "$TORTURE_KCONFIG_GDB_ARG"
68 config_override_param "--kasan options" KcList "$TORTURE_KCONFIG_KASAN_ARG"
69 config_override_param "--kcsan options" KcList "$TORTURE_KCONFIG_KCSAN_ARG"
70 config_override_param "--kconfig argument" KcList "$TORTURE_KCONFIG_ARG"
71 config_override_param "$config_dir/CFcommon.$(uname -m)" KcList \
72 "`cat $config_dir/CFcommon.$(uname -m) 2> /dev/null`"
73 cp $T/KcList $resdir/ConfigFragment
75 base_resdir=`echo $resdir | sed -e 's/\.[0-9]\+$//'`
76 if test "$base_resdir" != "$resdir" && test -f $base_resdir/bzImage && test -f $base_resdir/vmlinux
77 then
78 # Rerunning previous test, so use that test's kernel.
79 QEMU="`identify_qemu $base_resdir/vmlinux`"
80 BOOT_IMAGE="`identify_boot_image $QEMU`"
81 KERNEL=$base_resdir/${BOOT_IMAGE##*/} # use the last component of ${BOOT_IMAGE}
82 ln -s $base_resdir/Make*.out $resdir # for kvm-recheck.sh
83 ln -s $base_resdir/.config $resdir # for kvm-recheck.sh
84 # Arch-independent indicator
85 touch $resdir/builtkernel
86 elif test "$base_resdir" != "$resdir"
87 then
88 # Rerunning previous test for which build failed
89 ln -s $base_resdir/Make*.out $resdir # for kvm-recheck.sh
90 ln -s $base_resdir/.config $resdir # for kvm-recheck.sh
91 echo Initial build failed, not running KVM, see $resdir.
92 if test -f $resdir/build.wait
93 then
94 mv $resdir/build.wait $resdir/build.ready
96 exit 1
97 elif kvm-build.sh $T/KcList $resdir
98 then
99 # Had to build a kernel for this test.
100 QEMU="`identify_qemu vmlinux`"
101 BOOT_IMAGE="`identify_boot_image $QEMU`"
102 cp vmlinux $resdir
103 cp .config $resdir
104 cp Module.symvers $resdir > /dev/null || :
105 cp System.map $resdir > /dev/null || :
106 if test -n "$BOOT_IMAGE"
107 then
108 cp $BOOT_IMAGE $resdir
109 KERNEL=$resdir/${BOOT_IMAGE##*/}
110 # Arch-independent indicator
111 touch $resdir/builtkernel
112 else
113 echo No identifiable boot image, not running KVM, see $resdir.
114 echo Do the torture scripts know about your architecture?
116 parse-build.sh $resdir/Make.out $title
117 else
118 # Build failed.
119 cp .config $resdir || :
120 echo Build failed, not running KVM, see $resdir.
121 if test -f $resdir/build.wait
122 then
123 mv $resdir/build.wait $resdir/build.ready
125 exit 1
127 if test -f $resdir/build.wait
128 then
129 mv $resdir/build.wait $resdir/build.ready
131 while test -f $resdir/build.ready
133 sleep 1
134 done
135 seconds=$3
136 qemu_args=$4
137 boot_args_in=$5
139 if test -z "$TORTURE_BUILDONLY"
140 then
141 echo ' ---' `date`: Starting kernel
144 # Generate -smp qemu argument.
145 qemu_args="-enable-kvm -display none -no-reboot $qemu_args"
146 cpu_count=`configNR_CPUS.sh $resdir/ConfigFragment`
147 cpu_count=`configfrag_boot_cpus "$boot_args_in" "$config_template" "$cpu_count"`
148 if test "$cpu_count" -gt "$TORTURE_ALLOTED_CPUS"
149 then
150 echo CPU count limited from $cpu_count to $TORTURE_ALLOTED_CPUS | tee -a $resdir/Warnings
151 cpu_count=$TORTURE_ALLOTED_CPUS
153 qemu_args="`specify_qemu_cpus "$QEMU" "$qemu_args" "$cpu_count"`"
154 qemu_args="`specify_qemu_net "$qemu_args"`"
156 # Generate architecture-specific and interaction-specific qemu arguments
157 qemu_args="$qemu_args `identify_qemu_args "$QEMU" "$resdir/console.log"`"
159 # Generate qemu -append arguments
160 qemu_append="`identify_qemu_append "$QEMU"`"
162 # Pull in Kconfig-fragment boot parameters
163 boot_args="`configfrag_boot_params "$boot_args_in" "$config_template"`"
164 # Generate kernel-version-specific boot parameters
165 boot_args="`per_version_boot_params "$boot_args" $resdir/.config $seconds`"
166 if test -n "$TORTURE_BOOT_GDB_ARG"
167 then
168 boot_args="$TORTURE_BOOT_GDB_ARG $boot_args"
171 # Give bare-metal advice
172 modprobe_args="`echo $boot_args | tr -s ' ' '\012' | grep "^$TORTURE_MOD\." | sed -e "s/$TORTURE_MOD\.//g"`"
173 kboot_args="`echo $boot_args | tr -s ' ' '\012' | grep -v "^$TORTURE_MOD\."`"
174 testid_txt="`dirname $resdir`/testid.txt"
175 touch $resdir/bare-metal
176 echo To run this scenario on bare metal: >> $resdir/bare-metal
177 echo >> $resdir/bare-metal
178 echo " 1." Set your bare-metal build tree to the state shown in this file: >> $resdir/bare-metal
179 echo " " $testid_txt >> $resdir/bare-metal
180 echo " 2." Update your bare-metal build tree"'"s .config based on this file: >> $resdir/bare-metal
181 echo " " $resdir/ConfigFragment >> $resdir/bare-metal
182 echo " 3." Make the bare-metal kernel"'"s build system aware of your .config updates: >> $resdir/bare-metal
183 echo " " $ 'yes "" | make oldconfig' >> $resdir/bare-metal
184 echo " 4." Build your bare-metal kernel. >> $resdir/bare-metal
185 echo " 5." Boot your bare-metal kernel with the following parameters: >> $resdir/bare-metal
186 echo " " $kboot_args >> $resdir/bare-metal
187 echo " 6." Start the test with the following command: >> $resdir/bare-metal
188 echo " " $ modprobe $TORTURE_MOD $modprobe_args >> $resdir/bare-metal
189 echo " 7." After some time, end the test with the following command: >> $resdir/bare-metal
190 echo " " $ rmmod $TORTURE_MOD >> $resdir/bare-metal
191 echo " 8." Copy your bare-metal kernel"'"s .config file, overwriting this file: >> $resdir/bare-metal
192 echo " " $resdir/.config >> $resdir/bare-metal
193 echo " 9." Copy the console output from just before the modprobe to just after >> $resdir/bare-metal
194 echo " " the rmmod into this file: >> $resdir/bare-metal
195 echo " " $resdir/console.log >> $resdir/bare-metal
196 echo "10." Check for runtime errors using the following command: >> $resdir/bare-metal
197 echo " " $ tools/testing/selftests/rcutorture/bin/kvm-recheck.sh `dirname $resdir` >> $resdir/bare-metal
198 echo >> $resdir/bare-metal
199 echo Some of the above steps may be skipped if you build your bare-metal >> $resdir/bare-metal
200 echo kernel here: `head -n 1 $testid_txt | sed -e 's/^Build directory: //'` >> $resdir/bare-metal
202 echo $QEMU $qemu_args -m $TORTURE_QEMU_MEM -kernel $KERNEL -append \"$qemu_append $boot_args\" $TORTURE_QEMU_GDB_ARG > $resdir/qemu-cmd
203 echo "# TORTURE_SHUTDOWN_GRACE=$TORTURE_SHUTDOWN_GRACE" >> $resdir/qemu-cmd
204 echo "# seconds=$seconds" >> $resdir/qemu-cmd
205 echo "# TORTURE_KCONFIG_GDB_ARG=\"$TORTURE_KCONFIG_GDB_ARG\"" >> $resdir/qemu-cmd
206 echo "# TORTURE_JITTER_START=\"$TORTURE_JITTER_START\"" >> $resdir/qemu-cmd
207 echo "# TORTURE_JITTER_STOP=\"$TORTURE_JITTER_STOP\"" >> $resdir/qemu-cmd
208 echo "# TORTURE_TRUST_MAKE=\"$TORTURE_TRUST_MAKE\"; export TORTURE_TRUST_MAKE" >> $resdir/qemu-cmd
209 echo "# TORTURE_CPU_COUNT=$cpu_count" >> $resdir/qemu-cmd
211 if test -n "$TORTURE_BUILDONLY"
212 then
213 echo Build-only run specified, boot/test omitted.
214 touch $resdir/buildonly
215 exit 0
218 kvm-test-1-run-qemu.sh $resdir
219 parse-console.sh $resdir/console.log $title